; (async () => {
    // polyfill
    if (!WebAssembly.instantiateStreaming) {
        WebAssembly.instantiateStreaming = async (response, importObject) => {
            const source = await response
            const buffer = await source.arrayBuffer()
            return await WebAssembly.instantiate(buffer, importObject)
        }
    }


    // go!
    const go = new Go()

    try {
        const response = fetch('gotris.wasm')
        const result = await WebAssembly.instantiateStreaming(response, go.importObject)
        await go.run(result.instance)
        document.querySelector('section').textContent = `Runtime error! See console for details.`
    } catch (error) {
        console.error(error)
        document.querySelector('section').textContent = `Load error! See console for details.`
    }
})();
